# !/usr/bin/env Python3
# -*- coding: utf-8 -*-
# @Author   : Akili Wang
# @FILE     : run.py
# @Time     : 2022年2月19日   16:53
# @Software : PyCharm
# @Email   : wz19980226@163.com
#   .--,       .--,
#  ( (  \.---./  ) )
#   '.__/o   o\__.'
#      {=  ^  =}
#       >  -  <
#      /       \
#     //       \\                   神兽保佑
#    //|   .   |\\                  代码无bug！
#    "'\       /'"_.-~^`'-.
#       \  _  /--'         `
#     ___)( )(___
#    (((__) (__)))
#    高山仰止，景行行止。虽不能至，心向往之。

import argparse
import warnings

from classification.interface import Interface

warnings.filterwarnings('ignore')  # 禁止出现wanrnings


def run():
    parser = argparse.ArgumentParser()
    parser.add_argument('--pro_name', '-pn', required=True,
                        choices=['BLCA', 'COAD', 'UCEC', 'SARC', 'LGG', 'CESC', 'BRCA', 'all'], type=str)
    parser.add_argument('--operate', '-o', required=True, choices=['select', 'classify', 'paper_record'], type=str)
    parser.add_argument('--fs_save_path', '-fsp', type=str)
    parser.add_argument('--fs_name', '-fsn', type=str,
                        choices=['TriVote', 'Lasso', 'Ridge', 'Pearson', 'Variance', 'MIC'])
    parser.add_argument('--fs_feanum', '-fsf', type=str)
    parser.add_argument('--clf_file_path', '-ffp', type=str)
    parser.add_argument('--clf_name', '-cn', type=str,
                        choices=['LinearSVC', 'KNN', 'GaussianNB', 'DecisionTreeClassifier', 'LogisticRegression',
                                 'RandomForestClassifier'])

    args = parser.parse_args()
    pro_name = args.pro_name
    operate = args.operate
    interface = Interface(pro_name)
    if operate == 'select':
        save_path = args.fs_save_path
        fs_name = args.fs_name
        feanum = args.fs_feanum
        interface.feature_select(save_path, fs_name, int(feanum))
    if operate == 'classify':
        file_path = args.clf_file_path
        clf_name = args.clf_name
        interface.data_classify(file_path, clf_name)
    if operate == 'paper_record':
        interface.get_record()
